#ifndef NAG_RWRAPPER_UTILS_H
#define NAG_RWRAPPER_UTILS_H

#include <R.h>
#include <Rinternals.h>

/* The FEXAMPLE preprocessor variable just controls whether we are 
   compiling a Fortran example or a C example. If it is defined then
   it is assumed that we are compiling a Fortran example
*/
/*#ifdef FEXAMPLE*/
#include "nagmk23.h"
/*
#else
#include <nag.h>
#include <nage04.h>
#define Integer int
#endif
*/
#define Nag_Boolean int
#define Nag_TRUE 1
#define Nag_FALSE 0
#define MAX(x,y) ((x)>=(y) ? (x) : (y)) /*maximum of two arguments */

extern void nag_convert_p2i(SEXP p, Integer *v);
extern void nag_convert_i2p(Integer *v, SEXP *p);
extern SEXP nag_getListElement(SEXP list, const char *str);
extern int nag_maxCharLenInCharVector(int n, SEXP v);
 
extern SEXP nag_d2r(int n, CONST double x[]);
extern SEXP nag_cplx2r(int n, CONST Complex x[]);
extern SEXP nag_2d2r(int n1, double x1[], int n2, double x2[]);
extern SEXP nag_i2r(int n, Integer x[]);
extern SEXP nag_fi2r(int n, CONST Integer x[]);
extern SEXP nag_l2r(int n, Integer x[]);
extern SEXP nag_l2l(int n, Nag_Boolean x[]);
extern SEXP nag_c2r(int n,  int lstring, int trim, char x[]);
/* nag_md2r: Take a matrix of doubles and return an matrix R object*/
extern SEXP nag_md2r(int cmajor, int nrow, int ncol, CONST double m[]);
extern SEXP nag_mi2r(int cmajor, int nrow, int ncol, Integer m[]);

extern int nag_isNumericVector(int n, SEXP v);
extern int nag_isLogicalVector(int n, SEXP v);
extern int nag_isNumericMatrix(int nrow, int ncol, SEXP m);
extern int nag_isIntegerMatrix(int nrow, int ncol, SEXP m);
extern int nag_isCharVector(int n, SEXP v);
extern int nag_extractInteger(SEXP n, Integer *cn);
extern int nag_extractDouble(SEXP d, double *cd);
extern int nag_extractComplex(SEXP c, Complex *cc);
extern int nag_extractDoubleVector(int n, SEXP v, double cv[]);
extern int nag_extractComplexVector(int n, SEXP v, Complex cv[]);
extern int nag_copyDoubleVector(int nrows, int ncols, double *toBeCopied, double **copy);
extern int nag_copyNagFortranIntegerVector(int nrows, int ncols, Integer *toBeCopied, Integer **copy);
extern int nag_extractNagFortranIntegerVector(int n, SEXP v, Integer cv[]);
extern int nag_extractLogicalVector(int n, SEXP v, Integer cv[]);
extern int nag_extractCharVector(int n, SEXP v, char cv[], int lstring);
extern int nag_initializeIntegerMatrix(int nrow, int ncol,  Integer cm[]);
extern int nag_initializeDoubleMatrix(int nrow, int ncol, double cm[]);
extern int nag_initializeComplexMatrix(int nrow, int ncol, Complex cm[]);
extern int nag_extractDoubleMatrix(int cmajor, int nrow, int ncol, SEXP m, double cm[]);
extern int nag_extractComplexMatrix(int cmajor, int nrow, int ncol, SEXP m, Complex cm[]);
extern int nag_extractIntegerMatrix(int cmajor, int nrow, int ncol, SEXP m, Integer cm[]);
extern int nag_getDoubleScalarFromList(const char *name, SEXP result, double *pvalue);
extern int nag_getDoubleMatrixFromList(const char *name, int cmajor, int nrow, int ncol, SEXP result, double rvector[]);
extern int nag_getIntegerMatrixFromList(const char *name, int cmajor, int nrow, int ncol, SEXP result, Integer ivector[]);
extern int nag_getIntFromList(const char *name, SEXP result, Integer *pvalue);

extern double nag_getMaxValueDoubleVector(int n, double cm[]);
extern int nag_getMaxValueIntegerVector(int n, Integer cm[]);

extern SEXP lang5(SEXP s, SEXP p1, SEXP p2, SEXP p3, SEXP p4);
extern SEXP lang6(SEXP s, SEXP p1, SEXP p2, SEXP p3, SEXP p4, SEXP p5);
extern SEXP lang7(SEXP s, SEXP p1, SEXP p2, SEXP p3, SEXP p4, SEXP p5, SEXP p6);
extern SEXP lang8(SEXP s, SEXP p1, SEXP p2, SEXP p3, SEXP p4, SEXP p5, SEXP p6, SEXP p7);
extern SEXP lang9(SEXP s, SEXP p1, SEXP p2, SEXP p3, SEXP p4, SEXP p5, SEXP p6, SEXP p7, SEXP p8);
extern SEXP lang10(SEXP s, SEXP p1, SEXP p2, SEXP p3, SEXP p4, SEXP p5, SEXP p6, SEXP p7, SEXP p8, SEXP p9);
extern SEXP lang11(SEXP s, SEXP p1, SEXP p2, SEXP p3, SEXP p4, SEXP p5, SEXP p6, SEXP p7, SEXP p8, SEXP p9, SEXP p10);
extern SEXP lang12(SEXP s, SEXP p1, SEXP p2, SEXP p3, SEXP p4, SEXP p5, SEXP p6, SEXP p7, SEXP p8, SEXP p9, SEXP p10, SEXP p11);
extern SEXP lang13(SEXP s, SEXP p1, SEXP p2, SEXP p3, SEXP p4, SEXP p5, SEXP p6, SEXP p7, SEXP p8, SEXP p9, SEXP p10, SEXP p11, SEXP p12);
extern SEXP lang14(SEXP s, SEXP p1, SEXP p2, SEXP p3, SEXP p4, SEXP p5, SEXP p6, SEXP p7, SEXP p8, SEXP p9, SEXP p10, SEXP p11, SEXP p12, SEXP p13);
extern SEXP lang15(SEXP s, SEXP p1, SEXP p2, SEXP p3, SEXP p4, SEXP p5, SEXP p6, SEXP p7, SEXP p8, SEXP p9, SEXP p10, SEXP p11, SEXP p12, SEXP p13, SEXP p14);


extern SEXP list5(SEXP s, SEXP l1, SEXP l2, SEXP l3, SEXP l4);
extern SEXP list6(SEXP s, SEXP l1, SEXP l2, SEXP l3, SEXP l4, SEXP l5);
extern SEXP list7(SEXP s, SEXP l1, SEXP l2, SEXP l3, SEXP l4, SEXP l5, SEXP l6);
extern SEXP list8(SEXP s, SEXP l1, SEXP l2, SEXP l3, SEXP l4, SEXP l5, SEXP l6, SEXP l7);
extern SEXP list9(SEXP s, SEXP l1, SEXP l2, SEXP l3, SEXP l4, SEXP l5, SEXP l6, SEXP l7,SEXP l8);
extern SEXP list10(SEXP s, SEXP l1, SEXP l2, SEXP l3, SEXP l4, SEXP l5, SEXP l6, SEXP l7,SEXP l8,SEXP l9);
extern SEXP list11(SEXP s, SEXP l1, SEXP l2, SEXP l3, SEXP l4, SEXP l5, SEXP l6, SEXP l7,SEXP l8,SEXP l9,SEXP l10);
extern SEXP list12(SEXP s, SEXP l1, SEXP l2, SEXP l3, SEXP l4, SEXP l5, SEXP l6, SEXP l7,SEXP l8,SEXP l9,SEXP l10,SEXP l11);
extern SEXP list13(SEXP s, SEXP l1, SEXP l2, SEXP l3, SEXP l4, SEXP l5, SEXP l6, SEXP l7,SEXP l8,SEXP l9,SEXP l10,SEXP l11,SEXP l12);
extern SEXP list14(SEXP s, SEXP l1, SEXP l2, SEXP l3, SEXP l4, SEXP l5, SEXP l6, SEXP l7,SEXP l8,SEXP l9,SEXP l10,SEXP l11,SEXP l12,SEXP l13);
extern SEXP list15(SEXP s, SEXP l1, SEXP l2, SEXP l3, SEXP l4, SEXP l5, SEXP l6, SEXP l7,SEXP l8,SEXP l9,SEXP l10,SEXP l11,SEXP l12,SEXP l13,SEXP l14);

#endif
